=begin
Trulioo Ruby SDK

Gem version: 1.0.3
Trulioo OpenAPI version: v1
Generated by OpenAPI Generator version: 5.0.1
=end

require 'cgi'

module Trulioo
  class ConfigurationApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Get Business Registration Numbers
    # Gets the currently configured business registration numbers, for country and an optionally supplied jurisdiction
    # @param mode [String] trial or live
    # @param country_code [String] Country alpha2 code, get via the call to https://developer.trulioo.com/reference#getcountrycodes
    # @param jurisdiction_code [String] Optional jurisdiction code, get via the call to https://developer.trulioo.com/reference#getcountrysubdivisions
    # @param [Hash] opts the optional parameters
    # @return [Array<BusinessRegistrationNumber>]
    def get_business_registration_numbers(mode, country_code, jurisdiction_code, opts = {})
      data, _status_code, _headers = get_business_registration_numbers_with_http_info(mode, country_code, jurisdiction_code, opts)
      data
    end

    # Get Business Registration Numbers
    # Gets the currently configured business registration numbers, for country and an optionally supplied jurisdiction
    # @param mode [String] trial or live
    # @param country_code [String] Country alpha2 code, get via the call to https://developer.trulioo.com/reference#getcountrycodes
    # @param jurisdiction_code [String] Optional jurisdiction code, get via the call to https://developer.trulioo.com/reference#getcountrysubdivisions
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<BusinessRegistrationNumber>, Integer, Hash)>] Array<BusinessRegistrationNumber> data, response status code and response headers
    def get_business_registration_numbers_with_http_info(mode, country_code, jurisdiction_code, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ConfigurationApi.get_business_registration_numbers ...'
      end
      # verify the required parameter 'mode' is set
      if @api_client.config.client_side_validation && mode.nil?
        fail ArgumentError, "Missing the required parameter 'mode' when calling ConfigurationApi.get_business_registration_numbers"
      end
      # verify the required parameter 'country_code' is set
      if @api_client.config.client_side_validation && country_code.nil?
        fail ArgumentError, "Missing the required parameter 'country_code' when calling ConfigurationApi.get_business_registration_numbers"
      end
      # verify the required parameter 'jurisdiction_code' is set
      if @api_client.config.client_side_validation && jurisdiction_code.nil?
        fail ArgumentError, "Missing the required parameter 'jurisdiction_code' when calling ConfigurationApi.get_business_registration_numbers"
      end
      # resource path
      local_var_path = '/{mode}/configuration/v1/businessregistrationnumbers/{countryCode}/{jurisdictionCode}'.sub('{' + 'mode' + '}', CGI.escape(mode.to_s).gsub('+', '%20')).sub('{' + 'countryCode' + '}', CGI.escape(country_code.to_s).gsub('+', '%20')).sub('{' + 'jurisdictionCode' + '}', CGI.escape(jurisdiction_code.to_s).gsub('+', '%20'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json', 'text/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'Array<BusinessRegistrationNumber>'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['ApiKeyAuth']

      new_options = opts.merge(
        :operation => :"ConfigurationApi.get_business_registration_numbers",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ConfigurationApi#get_business_registration_numbers\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get Consents
    # This method retrieves the consents required for data sources currently configured in your account configuration.   The response for this method contains a collection of strings that Verify method's ConsentForDataSources field expects to perform a verification using those data sources.   A failure to provide an element from the string collection will lead to a <a class=\"link-to-api\" href=\"#errors\">1005</a> service error.
    # @param mode [String] trial or live
    # @param configuration_name [String] The product configuration. Currently \&quot;Identity Verification\&quot; for all products.
    # @param country_code [String] Call CountryCodes to get the countries available to you.
    # @param [Hash] opts the optional parameters
    # @return [Array<String>]
    def get_consents(mode, configuration_name, country_code, opts = {})
      data, _status_code, _headers = get_consents_with_http_info(mode, configuration_name, country_code, opts)
      data
    end

    # Get Consents
    # This method retrieves the consents required for data sources currently configured in your account configuration.   The response for this method contains a collection of strings that Verify method&#39;s ConsentForDataSources field expects to perform a verification using those data sources.   A failure to provide an element from the string collection will lead to a &lt;a class&#x3D;\&quot;link-to-api\&quot; href&#x3D;\&quot;#errors\&quot;&gt;1005&lt;/a&gt; service error.
    # @param mode [String] trial or live
    # @param configuration_name [String] The product configuration. Currently \&quot;Identity Verification\&quot; for all products.
    # @param country_code [String] Call CountryCodes to get the countries available to you.
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<String>, Integer, Hash)>] Array<String> data, response status code and response headers
    def get_consents_with_http_info(mode, configuration_name, country_code, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ConfigurationApi.get_consents ...'
      end
      # verify the required parameter 'mode' is set
      if @api_client.config.client_side_validation && mode.nil?
        fail ArgumentError, "Missing the required parameter 'mode' when calling ConfigurationApi.get_consents"
      end
      # verify the required parameter 'configuration_name' is set
      if @api_client.config.client_side_validation && configuration_name.nil?
        fail ArgumentError, "Missing the required parameter 'configuration_name' when calling ConfigurationApi.get_consents"
      end
      # verify the required parameter 'country_code' is set
      if @api_client.config.client_side_validation && country_code.nil?
        fail ArgumentError, "Missing the required parameter 'country_code' when calling ConfigurationApi.get_consents"
      end
      # resource path
      local_var_path = '/{mode}/configuration/v1/consents/{configurationName}/{countryCode}'.sub('{' + 'mode' + '}', CGI.escape(mode.to_s).gsub('+', '%20')).sub('{' + 'configurationName' + '}', CGI.escape(configuration_name.to_s).gsub('+', '%20')).sub('{' + 'countryCode' + '}', CGI.escape(country_code.to_s).gsub('+', '%20'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json', 'text/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'Array<String>'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['ApiKeyAuth']

      new_options = opts.merge(
        :operation => :"ConfigurationApi.get_consents",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ConfigurationApi#get_consents\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get Country Codes
    # This method retrieves all the countries that are available to perform a verification.
    # @param mode [String] trial or live
    # @param configuration_name [String] The product configuration. Currently \&quot;Identity Verification\&quot; for all products.
    # @param [Hash] opts the optional parameters
    # @return [Array<String>]
    def get_country_codes(mode, configuration_name, opts = {})
      data, _status_code, _headers = get_country_codes_with_http_info(mode, configuration_name, opts)
      data
    end

    # Get Country Codes
    # This method retrieves all the countries that are available to perform a verification.
    # @param mode [String] trial or live
    # @param configuration_name [String] The product configuration. Currently \&quot;Identity Verification\&quot; for all products.
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<String>, Integer, Hash)>] Array<String> data, response status code and response headers
    def get_country_codes_with_http_info(mode, configuration_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ConfigurationApi.get_country_codes ...'
      end
      # verify the required parameter 'mode' is set
      if @api_client.config.client_side_validation && mode.nil?
        fail ArgumentError, "Missing the required parameter 'mode' when calling ConfigurationApi.get_country_codes"
      end
      # verify the required parameter 'configuration_name' is set
      if @api_client.config.client_side_validation && configuration_name.nil?
        fail ArgumentError, "Missing the required parameter 'configuration_name' when calling ConfigurationApi.get_country_codes"
      end
      # resource path
      local_var_path = '/{mode}/configuration/v1/countrycodes/{configurationName}'.sub('{' + 'mode' + '}', CGI.escape(mode.to_s).gsub('+', '%20')).sub('{' + 'configurationName' + '}', CGI.escape(configuration_name.to_s).gsub('+', '%20'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json', 'text/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'Array<String>'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['ApiKeyAuth']

      new_options = opts.merge(
        :operation => :"ConfigurationApi.get_country_codes",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ConfigurationApi#get_country_codes\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get Country Subdivisions
    # Gets the provinces states or other subdivisions for a country, mostly matches ISO 3166-2
    # @param mode [String] trial or live
    # @param country_code [String] Country alpha2 code, get the the call to countrycodes
    # @param [Hash] opts the optional parameters
    # @return [Array<CountrySubdivision>]
    def get_country_subdivisions(mode, country_code, opts = {})
      data, _status_code, _headers = get_country_subdivisions_with_http_info(mode, country_code, opts)
      data
    end

    # Get Country Subdivisions
    # Gets the provinces states or other subdivisions for a country, mostly matches ISO 3166-2
    # @param mode [String] trial or live
    # @param country_code [String] Country alpha2 code, get the the call to countrycodes
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<CountrySubdivision>, Integer, Hash)>] Array<CountrySubdivision> data, response status code and response headers
    def get_country_subdivisions_with_http_info(mode, country_code, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ConfigurationApi.get_country_subdivisions ...'
      end
      # verify the required parameter 'mode' is set
      if @api_client.config.client_side_validation && mode.nil?
        fail ArgumentError, "Missing the required parameter 'mode' when calling ConfigurationApi.get_country_subdivisions"
      end
      # verify the required parameter 'country_code' is set
      if @api_client.config.client_side_validation && country_code.nil?
        fail ArgumentError, "Missing the required parameter 'country_code' when calling ConfigurationApi.get_country_subdivisions"
      end
      # resource path
      local_var_path = '/{mode}/configuration/v1/countrysubdivisions/{countryCode}'.sub('{' + 'mode' + '}', CGI.escape(mode.to_s).gsub('+', '%20')).sub('{' + 'countryCode' + '}', CGI.escape(country_code.to_s).gsub('+', '%20'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json', 'text/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'Array<CountrySubdivision>'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['ApiKeyAuth']

      new_options = opts.merge(
        :operation => :"ConfigurationApi.get_country_subdivisions",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ConfigurationApi#get_country_subdivisions\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get Datasources
    # Gets datasource groups configured for your product and country.
    # @param mode [String] trial or live
    # @param configuration_name [String] The product configuration. Currently \&quot;Identity Verification\&quot; for all products.
    # @param country_code [String] Call CountryCodes to get the countries available to you.
    # @param [Hash] opts the optional parameters
    # @return [Array<NormalizedDatasourceGroupCountry>]
    def get_datasources(mode, configuration_name, country_code, opts = {})
      data, _status_code, _headers = get_datasources_with_http_info(mode, configuration_name, country_code, opts)
      data
    end

    # Get Datasources
    # Gets datasource groups configured for your product and country.
    # @param mode [String] trial or live
    # @param configuration_name [String] The product configuration. Currently \&quot;Identity Verification\&quot; for all products.
    # @param country_code [String] Call CountryCodes to get the countries available to you.
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<NormalizedDatasourceGroupCountry>, Integer, Hash)>] Array<NormalizedDatasourceGroupCountry> data, response status code and response headers
    def get_datasources_with_http_info(mode, configuration_name, country_code, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ConfigurationApi.get_datasources ...'
      end
      # verify the required parameter 'mode' is set
      if @api_client.config.client_side_validation && mode.nil?
        fail ArgumentError, "Missing the required parameter 'mode' when calling ConfigurationApi.get_datasources"
      end
      # verify the required parameter 'configuration_name' is set
      if @api_client.config.client_side_validation && configuration_name.nil?
        fail ArgumentError, "Missing the required parameter 'configuration_name' when calling ConfigurationApi.get_datasources"
      end
      # verify the required parameter 'country_code' is set
      if @api_client.config.client_side_validation && country_code.nil?
        fail ArgumentError, "Missing the required parameter 'country_code' when calling ConfigurationApi.get_datasources"
      end
      # resource path
      local_var_path = '/{mode}/configuration/v1/datasources/{configurationName}/{countryCode}'.sub('{' + 'mode' + '}', CGI.escape(mode.to_s).gsub('+', '%20')).sub('{' + 'configurationName' + '}', CGI.escape(configuration_name.to_s).gsub('+', '%20')).sub('{' + 'countryCode' + '}', CGI.escape(country_code.to_s).gsub('+', '%20'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json', 'text/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'Array<NormalizedDatasourceGroupCountry>'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['ApiKeyAuth']

      new_options = opts.merge(
        :operation => :"ConfigurationApi.get_datasources",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ConfigurationApi#get_datasources\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get Detailed Consents
    # This method retrieves details about consents required for data sources currently configured in your account configuration.   The response for this method contains a collection of objects.  Each object contains the Name of the data source, Text outlining what the user is consenting to, and optionally a Url where the user can find more information about how their data will be used.    Failure to provide a Name from the object collection will lead to a <a class=\"link-to-api\" href=\"#errors\">1005</a> service error.
    # @param mode [String] trial or live
    # @param configuration_name [String] The product configuration. Currently \&quot;Identity Verification\&quot; for all products.
    # @param country_code [String] Call CountryCodes to get the countries available to you.
    # @param [Hash] opts the optional parameters
    # @return [Array<Consent>]
    def get_detailed_consents(mode, configuration_name, country_code, opts = {})
      data, _status_code, _headers = get_detailed_consents_with_http_info(mode, configuration_name, country_code, opts)
      data
    end

    # Get Detailed Consents
    # This method retrieves details about consents required for data sources currently configured in your account configuration.   The response for this method contains a collection of objects.  Each object contains the Name of the data source, Text outlining what the user is consenting to, and optionally a Url where the user can find more information about how their data will be used.    Failure to provide a Name from the object collection will lead to a &lt;a class&#x3D;\&quot;link-to-api\&quot; href&#x3D;\&quot;#errors\&quot;&gt;1005&lt;/a&gt; service error.
    # @param mode [String] trial or live
    # @param configuration_name [String] The product configuration. Currently \&quot;Identity Verification\&quot; for all products.
    # @param country_code [String] Call CountryCodes to get the countries available to you.
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<Consent>, Integer, Hash)>] Array<Consent> data, response status code and response headers
    def get_detailed_consents_with_http_info(mode, configuration_name, country_code, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ConfigurationApi.get_detailed_consents ...'
      end
      # verify the required parameter 'mode' is set
      if @api_client.config.client_side_validation && mode.nil?
        fail ArgumentError, "Missing the required parameter 'mode' when calling ConfigurationApi.get_detailed_consents"
      end
      # verify the required parameter 'configuration_name' is set
      if @api_client.config.client_side_validation && configuration_name.nil?
        fail ArgumentError, "Missing the required parameter 'configuration_name' when calling ConfigurationApi.get_detailed_consents"
      end
      # verify the required parameter 'country_code' is set
      if @api_client.config.client_side_validation && country_code.nil?
        fail ArgumentError, "Missing the required parameter 'country_code' when calling ConfigurationApi.get_detailed_consents"
      end
      # resource path
      local_var_path = '/{mode}/configuration/v1/detailedConsents/{configurationName}/{countryCode}'.sub('{' + 'mode' + '}', CGI.escape(mode.to_s).gsub('+', '%20')).sub('{' + 'configurationName' + '}', CGI.escape(configuration_name.to_s).gsub('+', '%20')).sub('{' + 'countryCode' + '}', CGI.escape(country_code.to_s).gsub('+', '%20'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json', 'text/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'Array<Consent>'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['ApiKeyAuth']

      new_options = opts.merge(
        :operation => :"ConfigurationApi.get_detailed_consents",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ConfigurationApi#get_detailed_consents\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get Document Types
    # Gets the document types available for a country.
    # @param mode [String] trial or live
    # @param country_code [String] Call CountryCodes to get the countries available to you.
    # @param [Hash] opts the optional parameters
    # @return [Hash<String, Array<String>>]
    def get_document_types(mode, country_code, opts = {})
      data, _status_code, _headers = get_document_types_with_http_info(mode, country_code, opts)
      data
    end

    # Get Document Types
    # Gets the document types available for a country.
    # @param mode [String] trial or live
    # @param country_code [String] Call CountryCodes to get the countries available to you.
    # @param [Hash] opts the optional parameters
    # @return [Array<(Hash<String, Array<String>>, Integer, Hash)>] Hash<String, Array<String>> data, response status code and response headers
    def get_document_types_with_http_info(mode, country_code, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ConfigurationApi.get_document_types ...'
      end
      # verify the required parameter 'mode' is set
      if @api_client.config.client_side_validation && mode.nil?
        fail ArgumentError, "Missing the required parameter 'mode' when calling ConfigurationApi.get_document_types"
      end
      # verify the required parameter 'country_code' is set
      if @api_client.config.client_side_validation && country_code.nil?
        fail ArgumentError, "Missing the required parameter 'country_code' when calling ConfigurationApi.get_document_types"
      end
      # resource path
      local_var_path = '/{mode}/configuration/v1/documentTypes/{countryCode}'.sub('{' + 'mode' + '}', CGI.escape(mode.to_s).gsub('+', '%20')).sub('{' + 'countryCode' + '}', CGI.escape(country_code.to_s).gsub('+', '%20'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json', 'text/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'Hash<String, Array<String>>'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['ApiKeyAuth']

      new_options = opts.merge(
        :operation => :"ConfigurationApi.get_document_types",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ConfigurationApi#get_document_types\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get Fields
    # Generates json schema for the API, the schema is dynamic based on the country and configuration you are using.  http://json-schema.org/documentation.html
    # @param mode [String] trial or live
    # @param configuration_name [String] The product configuration. Currently \&quot;Identity Verification\&quot; for all products.
    # @param country_code [String] Call CountryCodes to get the countries available to you.
    # @param [Hash] opts the optional parameters
    # @return [Object]
    def get_fields(mode, configuration_name, country_code, opts = {})
      data, _status_code, _headers = get_fields_with_http_info(mode, configuration_name, country_code, opts)
      data
    end

    # Get Fields
    # Generates json schema for the API, the schema is dynamic based on the country and configuration you are using.  http://json-schema.org/documentation.html
    # @param mode [String] trial or live
    # @param configuration_name [String] The product configuration. Currently \&quot;Identity Verification\&quot; for all products.
    # @param country_code [String] Call CountryCodes to get the countries available to you.
    # @param [Hash] opts the optional parameters
    # @return [Array<(Object, Integer, Hash)>] Object data, response status code and response headers
    def get_fields_with_http_info(mode, configuration_name, country_code, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ConfigurationApi.get_fields ...'
      end
      # verify the required parameter 'mode' is set
      if @api_client.config.client_side_validation && mode.nil?
        fail ArgumentError, "Missing the required parameter 'mode' when calling ConfigurationApi.get_fields"
      end
      # verify the required parameter 'configuration_name' is set
      if @api_client.config.client_side_validation && configuration_name.nil?
        fail ArgumentError, "Missing the required parameter 'configuration_name' when calling ConfigurationApi.get_fields"
      end
      # verify the required parameter 'country_code' is set
      if @api_client.config.client_side_validation && country_code.nil?
        fail ArgumentError, "Missing the required parameter 'country_code' when calling ConfigurationApi.get_fields"
      end
      # resource path
      local_var_path = '/{mode}/configuration/v1/fields/{configurationName}/{countryCode}'.sub('{' + 'mode' + '}', CGI.escape(mode.to_s).gsub('+', '%20')).sub('{' + 'configurationName' + '}', CGI.escape(configuration_name.to_s).gsub('+', '%20')).sub('{' + 'countryCode' + '}', CGI.escape(country_code.to_s).gsub('+', '%20'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json', 'text/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'Object'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['ApiKeyAuth']

      new_options = opts.merge(
        :operation => :"ConfigurationApi.get_fields",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ConfigurationApi#get_fields\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get Recommended Fields
    # Generates json schema for the API, the schema is dynamic based on the recommendedFields country and account you are using.  http://json-schema.org/documentation.html
    # @param mode [String] trial or live
    # @param configuration_name [String] The product configuration. Currently \&quot;Identity Verification\&quot; for all products.
    # @param country_code [String] Call CountryCodes to get the countries available to you.
    # @param [Hash] opts the optional parameters
    # @return [Object]
    def get_recommended_fields(mode, configuration_name, country_code, opts = {})
      data, _status_code, _headers = get_recommended_fields_with_http_info(mode, configuration_name, country_code, opts)
      data
    end

    # Get Recommended Fields
    # Generates json schema for the API, the schema is dynamic based on the recommendedFields country and account you are using.  http://json-schema.org/documentation.html
    # @param mode [String] trial or live
    # @param configuration_name [String] The product configuration. Currently \&quot;Identity Verification\&quot; for all products.
    # @param country_code [String] Call CountryCodes to get the countries available to you.
    # @param [Hash] opts the optional parameters
    # @return [Array<(Object, Integer, Hash)>] Object data, response status code and response headers
    def get_recommended_fields_with_http_info(mode, configuration_name, country_code, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ConfigurationApi.get_recommended_fields ...'
      end
      # verify the required parameter 'mode' is set
      if @api_client.config.client_side_validation && mode.nil?
        fail ArgumentError, "Missing the required parameter 'mode' when calling ConfigurationApi.get_recommended_fields"
      end
      # verify the required parameter 'configuration_name' is set
      if @api_client.config.client_side_validation && configuration_name.nil?
        fail ArgumentError, "Missing the required parameter 'configuration_name' when calling ConfigurationApi.get_recommended_fields"
      end
      # verify the required parameter 'country_code' is set
      if @api_client.config.client_side_validation && country_code.nil?
        fail ArgumentError, "Missing the required parameter 'country_code' when calling ConfigurationApi.get_recommended_fields"
      end
      # resource path
      local_var_path = '/{mode}/configuration/v1/recommendedfields/{configurationName}/{countryCode}'.sub('{' + 'mode' + '}', CGI.escape(mode.to_s).gsub('+', '%20')).sub('{' + 'configurationName' + '}', CGI.escape(configuration_name.to_s).gsub('+', '%20')).sub('{' + 'countryCode' + '}', CGI.escape(country_code.to_s).gsub('+', '%20'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json', 'text/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'Object'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['ApiKeyAuth']

      new_options = opts.merge(
        :operation => :"ConfigurationApi.get_recommended_fields",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ConfigurationApi#get_recommended_fields\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get Test Entities
    # Gets the test entities configured for your product and country.
    # @param mode [String] trial or live
    # @param configuration_name [String] The product configuration. Currently \&quot;Identity Verification\&quot; for all products.
    # @param country_code [String] Call CountryCodes to get the countries available to you.
    # @param [Hash] opts the optional parameters
    # @return [Array<TestEntityDataFields>]
    def get_test_entities(mode, configuration_name, country_code, opts = {})
      data, _status_code, _headers = get_test_entities_with_http_info(mode, configuration_name, country_code, opts)
      data
    end

    # Get Test Entities
    # Gets the test entities configured for your product and country.
    # @param mode [String] trial or live
    # @param configuration_name [String] The product configuration. Currently \&quot;Identity Verification\&quot; for all products.
    # @param country_code [String] Call CountryCodes to get the countries available to you.
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<TestEntityDataFields>, Integer, Hash)>] Array<TestEntityDataFields> data, response status code and response headers
    def get_test_entities_with_http_info(mode, configuration_name, country_code, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ConfigurationApi.get_test_entities ...'
      end
      # verify the required parameter 'mode' is set
      if @api_client.config.client_side_validation && mode.nil?
        fail ArgumentError, "Missing the required parameter 'mode' when calling ConfigurationApi.get_test_entities"
      end
      # verify the required parameter 'configuration_name' is set
      if @api_client.config.client_side_validation && configuration_name.nil?
        fail ArgumentError, "Missing the required parameter 'configuration_name' when calling ConfigurationApi.get_test_entities"
      end
      # verify the required parameter 'country_code' is set
      if @api_client.config.client_side_validation && country_code.nil?
        fail ArgumentError, "Missing the required parameter 'country_code' when calling ConfigurationApi.get_test_entities"
      end
      # resource path
      local_var_path = '/{mode}/configuration/v1/testentities/{configurationName}/{countryCode}'.sub('{' + 'mode' + '}', CGI.escape(mode.to_s).gsub('+', '%20')).sub('{' + 'configurationName' + '}', CGI.escape(configuration_name.to_s).gsub('+', '%20')).sub('{' + 'countryCode' + '}', CGI.escape(country_code.to_s).gsub('+', '%20'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json', 'text/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'Array<TestEntityDataFields>'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['ApiKeyAuth']

      new_options = opts.merge(
        :operation => :"ConfigurationApi.get_test_entities",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ConfigurationApi#get_test_entities\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
