=begin
Trulioo Ruby SDK

Gem version: 1.0.3
Trulioo OpenAPI version: v1
Generated by OpenAPI Generator version: 5.0.1
=end

require 'cgi'

module Trulioo
  class ConnectionApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Connection Async Callback Url
    # If set, the transaction will run asynchronously and Trulioo will try to update the client with transaction state updates until completed. If callback is not desired but the client wants to initiate an asynchronous transaction, provide https://api.globaldatacompany.com/connection/v1/async-callback as the Callback URL.
    # @param mode [String] trial or live
    # @param transaction_status [TransactionStatus] transactionStatus
    # @param [Hash] opts the optional parameters
    # @return [Object]
    def connection_async_callback_url(mode, transaction_status, opts = {})
      data, _status_code, _headers = connection_async_callback_url_with_http_info(mode, transaction_status, opts)
      data
    end

    # Connection Async Callback Url
    # If set, the transaction will run asynchronously and Trulioo will try to update the client with transaction state updates until completed. If callback is not desired but the client wants to initiate an asynchronous transaction, provide https://api.globaldatacompany.com/connection/v1/async-callback as the Callback URL.
    # @param mode [String] trial or live
    # @param transaction_status [TransactionStatus] transactionStatus
    # @param [Hash] opts the optional parameters
    # @return [Array<(Object, Integer, Hash)>] Object data, response status code and response headers
    def connection_async_callback_url_with_http_info(mode, transaction_status, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ConnectionApi.connection_async_callback_url ...'
      end
      # verify the required parameter 'mode' is set
      if @api_client.config.client_side_validation && mode.nil?
        fail ArgumentError, "Missing the required parameter 'mode' when calling ConnectionApi.connection_async_callback_url"
      end
      # verify the required parameter 'transaction_status' is set
      if @api_client.config.client_side_validation && transaction_status.nil?
        fail ArgumentError, "Missing the required parameter 'transaction_status' when calling ConnectionApi.connection_async_callback_url"
      end
      # resource path
      local_var_path = '/{mode}/connection/v1/async-callback'.sub('{' + 'mode' + '}', CGI.escape(mode.to_s).gsub('+', '%20'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json', 'text/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'text/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(transaction_status)

      # return_type
      return_type = opts[:debug_return_type] || 'Object'

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"ConnectionApi.connection_async_callback_url",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ConnectionApi#connection_async_callback_url\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Say Hello
    # This method enables you to check if your system can connect to our system. You can even use a web browser to verify a connection to our system.  Applied a maximum length for the name parameter of 100 via a route constraint
    # @param mode [String] trial or live
    # @param name [String] Name to be returned in the response
    # @param [Hash] opts the optional parameters
    # @return [String]
    def say_hello(mode, name, opts = {})
      data, _status_code, _headers = say_hello_with_http_info(mode, name, opts)
      data
    end

    # Say Hello
    # This method enables you to check if your system can connect to our system. You can even use a web browser to verify a connection to our system.  Applied a maximum length for the name parameter of 100 via a route constraint
    # @param mode [String] trial or live
    # @param name [String] Name to be returned in the response
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Integer, Hash)>] String data, response status code and response headers
    def say_hello_with_http_info(mode, name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ConnectionApi.say_hello ...'
      end
      # verify the required parameter 'mode' is set
      if @api_client.config.client_side_validation && mode.nil?
        fail ArgumentError, "Missing the required parameter 'mode' when calling ConnectionApi.say_hello"
      end
      # verify the required parameter 'name' is set
      if @api_client.config.client_side_validation && name.nil?
        fail ArgumentError, "Missing the required parameter 'name' when calling ConnectionApi.say_hello"
      end
      # resource path
      local_var_path = '/{mode}/connection/v1/sayhello/{name}'.sub('{' + 'mode' + '}', CGI.escape(mode.to_s).gsub('+', '%20')).sub('{' + 'name' + '}', CGI.escape(name.to_s).gsub('+', '%20'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json', 'text/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'String'

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"ConnectionApi.say_hello",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ConnectionApi#say_hello\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Test Authentication
    # This method enables you to check if your credentials are valid. You will need to use basic authentication to ensure a successful response.
    # @param mode [String] trial or live
    # @param [Hash] opts the optional parameters
    # @return [String]
    def test_authentication(mode, opts = {})
      data, _status_code, _headers = test_authentication_with_http_info(mode, opts)
      data
    end

    # Test Authentication
    # This method enables you to check if your credentials are valid. You will need to use basic authentication to ensure a successful response.
    # @param mode [String] trial or live
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Integer, Hash)>] String data, response status code and response headers
    def test_authentication_with_http_info(mode, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ConnectionApi.test_authentication ...'
      end
      # verify the required parameter 'mode' is set
      if @api_client.config.client_side_validation && mode.nil?
        fail ArgumentError, "Missing the required parameter 'mode' when calling ConnectionApi.test_authentication"
      end
      # resource path
      local_var_path = '/{mode}/connection/v1/testauthentication'.sub('{' + 'mode' + '}', CGI.escape(mode.to_s).gsub('+', '%20'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json', 'text/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'String'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['ApiKeyAuth']

      new_options = opts.merge(
        :operation => :"ConnectionApi.test_authentication",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ConnectionApi#test_authentication\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
