=begin
Trulioo Ruby SDK

Gem version: 1.0.3
Trulioo OpenAPI version: v1
Generated by OpenAPI Generator version: 5.0.1
=end

require 'cgi'

module Trulioo
  class VerificationsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Document Download
    # Download Document
    # @param mode [String] trial or live
    # @param transaction_record_id [String] id of the transactionrecord, this will be a GUID
    # @param field_name [String] document field name
    # @param [Hash] opts the optional parameters
    # @return [Object]
    def document_download(mode, transaction_record_id, field_name, opts = {})
      data, _status_code, _headers = document_download_with_http_info(mode, transaction_record_id, field_name, opts)
      data
    end

    # Document Download
    # Download Document
    # @param mode [String] trial or live
    # @param transaction_record_id [String] id of the transactionrecord, this will be a GUID
    # @param field_name [String] document field name
    # @param [Hash] opts the optional parameters
    # @return [Array<(Object, Integer, Hash)>] Object data, response status code and response headers
    def document_download_with_http_info(mode, transaction_record_id, field_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: VerificationsApi.document_download ...'
      end
      # verify the required parameter 'mode' is set
      if @api_client.config.client_side_validation && mode.nil?
        fail ArgumentError, "Missing the required parameter 'mode' when calling VerificationsApi.document_download"
      end
      # verify the required parameter 'transaction_record_id' is set
      if @api_client.config.client_side_validation && transaction_record_id.nil?
        fail ArgumentError, "Missing the required parameter 'transaction_record_id' when calling VerificationsApi.document_download"
      end
      # verify the required parameter 'field_name' is set
      if @api_client.config.client_side_validation && field_name.nil?
        fail ArgumentError, "Missing the required parameter 'field_name' when calling VerificationsApi.document_download"
      end
      # resource path
      local_var_path = '/{mode}/verifications/v1/documentdownload/{transactionRecordId}/{fieldName}'.sub('{' + 'mode' + '}', CGI.escape(mode.to_s).gsub('+', '%20')).sub('{' + 'transactionRecordId' + '}', CGI.escape(transaction_record_id.to_s).gsub('+', '%20')).sub('{' + 'fieldName' + '}', CGI.escape(field_name.to_s).gsub('+', '%20'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json', 'text/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'Object'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['ApiKeyAuth']

      new_options = opts.merge(
        :operation => :"VerificationsApi.document_download",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: VerificationsApi#document_download\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get Transaction Record
    # This method is used to retrieve the request and results of a verification performed using the verify method.  The response for this method includes the same information as verify method's response, along with data present in the input fields of the verify request.
    # @param mode [String] trial or live
    # @param id [String] id of the transactionrecord, this will be a GUID
    # @param [Hash] opts the optional parameters
    # @return [TransactionRecordResult]
    def get_transaction_record(mode, id, opts = {})
      data, _status_code, _headers = get_transaction_record_with_http_info(mode, id, opts)
      data
    end

    # Get Transaction Record
    # This method is used to retrieve the request and results of a verification performed using the verify method.  The response for this method includes the same information as verify method&#39;s response, along with data present in the input fields of the verify request.
    # @param mode [String] trial or live
    # @param id [String] id of the transactionrecord, this will be a GUID
    # @param [Hash] opts the optional parameters
    # @return [Array<(TransactionRecordResult, Integer, Hash)>] TransactionRecordResult data, response status code and response headers
    def get_transaction_record_with_http_info(mode, id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: VerificationsApi.get_transaction_record ...'
      end
      # verify the required parameter 'mode' is set
      if @api_client.config.client_side_validation && mode.nil?
        fail ArgumentError, "Missing the required parameter 'mode' when calling VerificationsApi.get_transaction_record"
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling VerificationsApi.get_transaction_record"
      end
      # resource path
      local_var_path = '/{mode}/verifications/v1/transactionrecord/{id}'.sub('{' + 'mode' + '}', CGI.escape(mode.to_s).gsub('+', '%20')).sub('{' + 'id' + '}', CGI.escape(id.to_s).gsub('+', '%20'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json', 'text/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'TransactionRecordResult'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['ApiKeyAuth']

      new_options = opts.merge(
        :operation => :"VerificationsApi.get_transaction_record",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: VerificationsApi#get_transaction_record\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get Transaction Record Address
    # Fetch the results of a verification with the TransactionRecordId for the transaction this will include additional information if your account  includes address cleansing.
    # @param mode [String] trial or live
    # @param id [String] id of the transactionrecord, this will be a GUID
    # @param [Hash] opts the optional parameters
    # @return [TransactionRecordResult]
    def get_transaction_record_address(mode, id, opts = {})
      data, _status_code, _headers = get_transaction_record_address_with_http_info(mode, id, opts)
      data
    end

    # Get Transaction Record Address
    # Fetch the results of a verification with the TransactionRecordId for the transaction this will include additional information if your account  includes address cleansing.
    # @param mode [String] trial or live
    # @param id [String] id of the transactionrecord, this will be a GUID
    # @param [Hash] opts the optional parameters
    # @return [Array<(TransactionRecordResult, Integer, Hash)>] TransactionRecordResult data, response status code and response headers
    def get_transaction_record_address_with_http_info(mode, id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: VerificationsApi.get_transaction_record_address ...'
      end
      # verify the required parameter 'mode' is set
      if @api_client.config.client_side_validation && mode.nil?
        fail ArgumentError, "Missing the required parameter 'mode' when calling VerificationsApi.get_transaction_record_address"
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling VerificationsApi.get_transaction_record_address"
      end
      # resource path
      local_var_path = '/{mode}/verifications/v1/transactionrecord/{id}/withaddress'.sub('{' + 'mode' + '}', CGI.escape(mode.to_s).gsub('+', '%20')).sub('{' + 'id' + '}', CGI.escape(id.to_s).gsub('+', '%20'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json', 'text/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'TransactionRecordResult'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['ApiKeyAuth']

      new_options = opts.merge(
        :operation => :"VerificationsApi.get_transaction_record_address",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: VerificationsApi#get_transaction_record_address\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get Transaction Record Document
    # This method is used to retrieve the document of a verification performed using the verify method.  The response for this method includes the processed base64 JPEG formatted string
    # @param mode [String] trial or live
    # @param transaction_record_id [String] id of the transactionrecord, this will be a GUID
    # @param document_field [String] FieldName of the Document, this will be a string
    # @param [Hash] opts the optional parameters
    # @return [String]
    def get_transaction_record_document(mode, transaction_record_id, document_field, opts = {})
      data, _status_code, _headers = get_transaction_record_document_with_http_info(mode, transaction_record_id, document_field, opts)
      data
    end

    # Get Transaction Record Document
    # This method is used to retrieve the document of a verification performed using the verify method.  The response for this method includes the processed base64 JPEG formatted string
    # @param mode [String] trial or live
    # @param transaction_record_id [String] id of the transactionrecord, this will be a GUID
    # @param document_field [String] FieldName of the Document, this will be a string
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Integer, Hash)>] String data, response status code and response headers
    def get_transaction_record_document_with_http_info(mode, transaction_record_id, document_field, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: VerificationsApi.get_transaction_record_document ...'
      end
      # verify the required parameter 'mode' is set
      if @api_client.config.client_side_validation && mode.nil?
        fail ArgumentError, "Missing the required parameter 'mode' when calling VerificationsApi.get_transaction_record_document"
      end
      # verify the required parameter 'transaction_record_id' is set
      if @api_client.config.client_side_validation && transaction_record_id.nil?
        fail ArgumentError, "Missing the required parameter 'transaction_record_id' when calling VerificationsApi.get_transaction_record_document"
      end
      # verify the required parameter 'document_field' is set
      if @api_client.config.client_side_validation && document_field.nil?
        fail ArgumentError, "Missing the required parameter 'document_field' when calling VerificationsApi.get_transaction_record_document"
      end
      # resource path
      local_var_path = '/{mode}/verifications/v1/transactionrecord/{transactionRecordID}/{documentField}'.sub('{' + 'mode' + '}', CGI.escape(mode.to_s).gsub('+', '%20')).sub('{' + 'transactionRecordID' + '}', CGI.escape(transaction_record_id.to_s).gsub('+', '%20')).sub('{' + 'documentField' + '}', CGI.escape(document_field.to_s).gsub('+', '%20'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json', 'text/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'String'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['ApiKeyAuth']

      new_options = opts.merge(
        :operation => :"VerificationsApi.get_transaction_record_document",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: VerificationsApi#get_transaction_record_document\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get Transaction Record Verbose
    # Fetch the results of a verification with the TransactionRecordId for the transaction this will include additional information if your account  includes address cleansing and watchlist details.
    # @param mode [String] trial or live
    # @param id [String] id of the transactionrecord, this will be a GUID
    # @param [Hash] opts the optional parameters
    # @return [TransactionRecordResult]
    def get_transaction_record_verbose(mode, id, opts = {})
      data, _status_code, _headers = get_transaction_record_verbose_with_http_info(mode, id, opts)
      data
    end

    # Get Transaction Record Verbose
    # Fetch the results of a verification with the TransactionRecordId for the transaction this will include additional information if your account  includes address cleansing and watchlist details.
    # @param mode [String] trial or live
    # @param id [String] id of the transactionrecord, this will be a GUID
    # @param [Hash] opts the optional parameters
    # @return [Array<(TransactionRecordResult, Integer, Hash)>] TransactionRecordResult data, response status code and response headers
    def get_transaction_record_verbose_with_http_info(mode, id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: VerificationsApi.get_transaction_record_verbose ...'
      end
      # verify the required parameter 'mode' is set
      if @api_client.config.client_side_validation && mode.nil?
        fail ArgumentError, "Missing the required parameter 'mode' when calling VerificationsApi.get_transaction_record_verbose"
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling VerificationsApi.get_transaction_record_verbose"
      end
      # resource path
      local_var_path = '/{mode}/verifications/v1/transactionrecord/{id}/verbose'.sub('{' + 'mode' + '}', CGI.escape(mode.to_s).gsub('+', '%20')).sub('{' + 'id' + '}', CGI.escape(id.to_s).gsub('+', '%20'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json', 'text/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'TransactionRecordResult'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['ApiKeyAuth']

      new_options = opts.merge(
        :operation => :"VerificationsApi.get_transaction_record_verbose",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: VerificationsApi#get_transaction_record_verbose\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get Transaction Status
    # This method is used to retrieve the processing status of an asynchronous transaction. The response for this method includes the processing status of the verification, the TransactionID, the TransactionRecordID as well as whether the verification request has timed out.
    # @param mode [String] trial or live
    # @param id [String] id of the asynchronous transaction, this will be a GUID
    # @param [Hash] opts the optional parameters
    # @return [TransactionStatus]
    def get_transaction_status(mode, id, opts = {})
      data, _status_code, _headers = get_transaction_status_with_http_info(mode, id, opts)
      data
    end

    # Get Transaction Status
    # This method is used to retrieve the processing status of an asynchronous transaction. The response for this method includes the processing status of the verification, the TransactionID, the TransactionRecordID as well as whether the verification request has timed out.
    # @param mode [String] trial or live
    # @param id [String] id of the asynchronous transaction, this will be a GUID
    # @param [Hash] opts the optional parameters
    # @return [Array<(TransactionStatus, Integer, Hash)>] TransactionStatus data, response status code and response headers
    def get_transaction_status_with_http_info(mode, id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: VerificationsApi.get_transaction_status ...'
      end
      # verify the required parameter 'mode' is set
      if @api_client.config.client_side_validation && mode.nil?
        fail ArgumentError, "Missing the required parameter 'mode' when calling VerificationsApi.get_transaction_status"
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling VerificationsApi.get_transaction_status"
      end
      # resource path
      local_var_path = '/{mode}/verifications/v1/transaction/{id}/status'.sub('{' + 'mode' + '}', CGI.escape(mode.to_s).gsub('+', '%20')).sub('{' + 'id' + '}', CGI.escape(id.to_s).gsub('+', '%20'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json', 'text/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'TransactionStatus'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['ApiKeyAuth']

      new_options = opts.merge(
        :operation => :"VerificationsApi.get_transaction_status",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: VerificationsApi#get_transaction_status\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Verify
    # Calling this method will perform a verification. If your account includes address cleansing set the CleansedAddress flag to get  additional address information in the result.  You can query configuration to get what fields are available to you in each each country.  It is also possible to get sample requests from the customer portal.
    # @param mode [String] trial or live
    # @param verify_request [VerifyRequest] 
    # @param [Hash] opts the optional parameters
    # @return [VerifyResult]
    def verify(mode, verify_request, opts = {})
      data, _status_code, _headers = verify_with_http_info(mode, verify_request, opts)
      data
    end

    # Verify
    # Calling this method will perform a verification. If your account includes address cleansing set the CleansedAddress flag to get  additional address information in the result.  You can query configuration to get what fields are available to you in each each country.  It is also possible to get sample requests from the customer portal.
    # @param mode [String] trial or live
    # @param verify_request [VerifyRequest] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(VerifyResult, Integer, Hash)>] VerifyResult data, response status code and response headers
    def verify_with_http_info(mode, verify_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: VerificationsApi.verify ...'
      end
      # verify the required parameter 'mode' is set
      if @api_client.config.client_side_validation && mode.nil?
        fail ArgumentError, "Missing the required parameter 'mode' when calling VerificationsApi.verify"
      end
      # verify the required parameter 'verify_request' is set
      if @api_client.config.client_side_validation && verify_request.nil?
        fail ArgumentError, "Missing the required parameter 'verify_request' when calling VerificationsApi.verify"
      end
      # resource path
      local_var_path = '/{mode}/verifications/v1/verify'.sub('{' + 'mode' + '}', CGI.escape(mode.to_s).gsub('+', '%20'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json', 'text/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'text/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(verify_request)

      # return_type
      return_type = opts[:debug_return_type] || 'VerifyResult'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['ApiKeyAuth']

      new_options = opts.merge(
        :operation => :"VerificationsApi.verify",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: VerificationsApi#verify\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
