=begin
Trulioo Ruby SDK

Gem version: 1.0.3
Trulioo OpenAPI version: v1
Generated by OpenAPI Generator version: 5.0.1
=end

require 'date'
require 'time'

module Trulioo
  class Business
    # Name of the business to be verified
    attr_accessor :business_name

    # Registration number of business to be verified
    attr_accessor :business_registration_number

    # Day of incorporation of the business to be verified
    attr_accessor :day_of_incorporation

    # Month of incorporation of the business to be verified
    attr_accessor :month_of_incorporation

    # Year of incorporation of the business to be verified
    attr_accessor :year_of_incorporation

    # Jurisdiction Of Incorporation of the business to be verified
    attr_accessor :jurisdiction_of_incorporation

    # Whether or not to retrieve shareholderList document
    attr_accessor :shareholder_list_document

    # Whether or not to retrieve financial information document
    attr_accessor :financial_information_document

    # Duns Number
    attr_accessor :duns_number

    # Whether or not to retrieve entity detail
    attr_accessor :entities

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'business_name' => :'BusinessName',
        :'business_registration_number' => :'BusinessRegistrationNumber',
        :'day_of_incorporation' => :'DayOfIncorporation',
        :'month_of_incorporation' => :'MonthOfIncorporation',
        :'year_of_incorporation' => :'YearOfIncorporation',
        :'jurisdiction_of_incorporation' => :'JurisdictionOfIncorporation',
        :'shareholder_list_document' => :'ShareholderListDocument',
        :'financial_information_document' => :'FinancialInformationDocument',
        :'duns_number' => :'DunsNumber',
        :'entities' => :'Entities'
      }
    end

    # Returns all the JSON keys this model knows about
    def self.acceptable_attributes
      attribute_map.values
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'business_name' => :'String',
        :'business_registration_number' => :'String',
        :'day_of_incorporation' => :'Integer',
        :'month_of_incorporation' => :'Integer',
        :'year_of_incorporation' => :'Integer',
        :'jurisdiction_of_incorporation' => :'String',
        :'shareholder_list_document' => :'Boolean',
        :'financial_information_document' => :'Boolean',
        :'duns_number' => :'String',
        :'entities' => :'Boolean'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Trulioo::Business` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Trulioo::Business`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'business_name')
        self.business_name = attributes[:'business_name']
      end

      if attributes.key?(:'business_registration_number')
        self.business_registration_number = attributes[:'business_registration_number']
      end

      if attributes.key?(:'day_of_incorporation')
        self.day_of_incorporation = attributes[:'day_of_incorporation']
      end

      if attributes.key?(:'month_of_incorporation')
        self.month_of_incorporation = attributes[:'month_of_incorporation']
      end

      if attributes.key?(:'year_of_incorporation')
        self.year_of_incorporation = attributes[:'year_of_incorporation']
      end

      if attributes.key?(:'jurisdiction_of_incorporation')
        self.jurisdiction_of_incorporation = attributes[:'jurisdiction_of_incorporation']
      end

      if attributes.key?(:'shareholder_list_document')
        self.shareholder_list_document = attributes[:'shareholder_list_document']
      end

      if attributes.key?(:'financial_information_document')
        self.financial_information_document = attributes[:'financial_information_document']
      end

      if attributes.key?(:'duns_number')
        self.duns_number = attributes[:'duns_number']
      end

      if attributes.key?(:'entities')
        self.entities = attributes[:'entities']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          business_name == o.business_name &&
          business_registration_number == o.business_registration_number &&
          day_of_incorporation == o.day_of_incorporation &&
          month_of_incorporation == o.month_of_incorporation &&
          year_of_incorporation == o.year_of_incorporation &&
          jurisdiction_of_incorporation == o.jurisdiction_of_incorporation &&
          shareholder_list_document == o.shareholder_list_document &&
          financial_information_document == o.financial_information_document &&
          duns_number == o.duns_number &&
          entities == o.entities
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [business_name, business_registration_number, day_of_incorporation, month_of_incorporation, year_of_incorporation, jurisdiction_of_incorporation, shareholder_list_document, financial_information_document, duns_number, entities].hash
    end

    # :nocov:
    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end
    # :nocov:

    # :nocov:
    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        elsif type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end
      end

      self
    end
    # :nocov:

    # :nocov:
    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :Time
        Time.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        # models (e.g. Pet) or oneOf
        klass = Trulioo.const_get(type)
        klass.respond_to?(:openapi_one_of) ? klass.build(value) : klass.build_from_hash(value)
      end
    end
    # :nocov:

    # :nocov:
    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end
    # :nocov:

    # :nocov:
    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end
    # :nocov:

    # :nocov:
    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end
    # :nocov:

    # :nocov:
    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
    # :nocov:
  end

end
