=begin
Trulioo Ruby SDK

Gem version: 1.0.3
Trulioo OpenAPI version: v1
Generated by OpenAPI Generator version: 5.0.1
=end

require 'date'
require 'time'

module Trulioo
  class Communication
    # Mobile phone number
    attr_accessor :mobile_number

    # Telephone number of the individual to be verified
    attr_accessor :telephone

    # Additional Phone/Mobile Number of the individual to be verified
    attr_accessor :telephone2

    # Email address of the individual to be verified
    attr_accessor :email_address

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'mobile_number' => :'MobileNumber',
        :'telephone' => :'Telephone',
        :'telephone2' => :'Telephone2',
        :'email_address' => :'EmailAddress'
      }
    end

    # Returns all the JSON keys this model knows about
    def self.acceptable_attributes
      attribute_map.values
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'mobile_number' => :'String',
        :'telephone' => :'String',
        :'telephone2' => :'String',
        :'email_address' => :'String'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Trulioo::Communication` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Trulioo::Communication`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'mobile_number')
        self.mobile_number = attributes[:'mobile_number']
      end

      if attributes.key?(:'telephone')
        self.telephone = attributes[:'telephone']
      end

      if attributes.key?(:'telephone2')
        self.telephone2 = attributes[:'telephone2']
      end

      if attributes.key?(:'email_address')
        self.email_address = attributes[:'email_address']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@mobile_number.nil? && @mobile_number.to_s.length > 200
        invalid_properties.push('invalid value for "mobile_number", the character length must be smaller than or equal to 200.')
      end

      if !@mobile_number.nil? && @mobile_number.to_s.length < 0
        invalid_properties.push('invalid value for "mobile_number", the character length must be great than or equal to 0.')
      end

      if !@telephone.nil? && @telephone.to_s.length > 200
        invalid_properties.push('invalid value for "telephone", the character length must be smaller than or equal to 200.')
      end

      if !@telephone.nil? && @telephone.to_s.length < 0
        invalid_properties.push('invalid value for "telephone", the character length must be great than or equal to 0.')
      end

      if !@telephone2.nil? && @telephone2.to_s.length > 200
        invalid_properties.push('invalid value for "telephone2", the character length must be smaller than or equal to 200.')
      end

      if !@telephone2.nil? && @telephone2.to_s.length < 0
        invalid_properties.push('invalid value for "telephone2", the character length must be great than or equal to 0.')
      end

      if !@email_address.nil? && @email_address.to_s.length > 200
        invalid_properties.push('invalid value for "email_address", the character length must be smaller than or equal to 200.')
      end

      if !@email_address.nil? && @email_address.to_s.length < 0
        invalid_properties.push('invalid value for "email_address", the character length must be great than or equal to 0.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@mobile_number.nil? && @mobile_number.to_s.length > 200
      return false if !@mobile_number.nil? && @mobile_number.to_s.length < 0
      return false if !@telephone.nil? && @telephone.to_s.length > 200
      return false if !@telephone.nil? && @telephone.to_s.length < 0
      return false if !@telephone2.nil? && @telephone2.to_s.length > 200
      return false if !@telephone2.nil? && @telephone2.to_s.length < 0
      return false if !@email_address.nil? && @email_address.to_s.length > 200
      return false if !@email_address.nil? && @email_address.to_s.length < 0
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] mobile_number Value to be assigned
    def mobile_number=(mobile_number)
      if !mobile_number.nil? && mobile_number.to_s.length > 200
        fail ArgumentError, 'invalid value for "mobile_number", the character length must be smaller than or equal to 200.'
      end

      if !mobile_number.nil? && mobile_number.to_s.length < 0
        fail ArgumentError, 'invalid value for "mobile_number", the character length must be great than or equal to 0.'
      end

      @mobile_number = mobile_number
    end

    # Custom attribute writer method with validation
    # @param [Object] telephone Value to be assigned
    def telephone=(telephone)
      if !telephone.nil? && telephone.to_s.length > 200
        fail ArgumentError, 'invalid value for "telephone", the character length must be smaller than or equal to 200.'
      end

      if !telephone.nil? && telephone.to_s.length < 0
        fail ArgumentError, 'invalid value for "telephone", the character length must be great than or equal to 0.'
      end

      @telephone = telephone
    end

    # Custom attribute writer method with validation
    # @param [Object] telephone2 Value to be assigned
    def telephone2=(telephone2)
      if !telephone2.nil? && telephone2.to_s.length > 200
        fail ArgumentError, 'invalid value for "telephone2", the character length must be smaller than or equal to 200.'
      end

      if !telephone2.nil? && telephone2.to_s.length < 0
        fail ArgumentError, 'invalid value for "telephone2", the character length must be great than or equal to 0.'
      end

      @telephone2 = telephone2
    end

    # Custom attribute writer method with validation
    # @param [Object] email_address Value to be assigned
    def email_address=(email_address)
      if !email_address.nil? && email_address.to_s.length > 200
        fail ArgumentError, 'invalid value for "email_address", the character length must be smaller than or equal to 200.'
      end

      if !email_address.nil? && email_address.to_s.length < 0
        fail ArgumentError, 'invalid value for "email_address", the character length must be great than or equal to 0.'
      end

      @email_address = email_address
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          mobile_number == o.mobile_number &&
          telephone == o.telephone &&
          telephone2 == o.telephone2 &&
          email_address == o.email_address
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [mobile_number, telephone, telephone2, email_address].hash
    end

    # :nocov:
    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end
    # :nocov:

    # :nocov:
    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        elsif type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end
      end

      self
    end
    # :nocov:

    # :nocov:
    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :Time
        Time.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        # models (e.g. Pet) or oneOf
        klass = Trulioo.const_get(type)
        klass.respond_to?(:openapi_one_of) ? klass.build(value) : klass.build_from_hash(value)
      end
    end
    # :nocov:

    # :nocov:
    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end
    # :nocov:

    # :nocov:
    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end
    # :nocov:

    # :nocov:
    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end
    # :nocov:

    # :nocov:
    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
    # :nocov:
  end

end
