=begin
Trulioo Ruby SDK

Gem version: 1.0.3
Trulioo OpenAPI version: v1
Generated by OpenAPI Generator version: 5.0.1
=end

require 'date'
require 'time'

module Trulioo
  # Datasource group config for country
  class NormalizedDatasourceGroupCountry
    # Name
    attr_accessor :name

    # Description
    attr_accessor :description

    # Required Fields
    attr_accessor :required_fields

    # Optional Fields
    attr_accessor :optional_fields

    # Appended Fields
    attr_accessor :appended_fields

    # Output Fields
    attr_accessor :output_fields

    # Source Type
    attr_accessor :source_type

    # Update Frequency
    attr_accessor :update_frequency

    # Coverage
    attr_accessor :coverage

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'name' => :'Name',
        :'description' => :'Description',
        :'required_fields' => :'RequiredFields',
        :'optional_fields' => :'OptionalFields',
        :'appended_fields' => :'AppendedFields',
        :'output_fields' => :'OutputFields',
        :'source_type' => :'SourceType',
        :'update_frequency' => :'UpdateFrequency',
        :'coverage' => :'Coverage'
      }
    end

    # Returns all the JSON keys this model knows about
    def self.acceptable_attributes
      attribute_map.values
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'name' => :'String',
        :'description' => :'String',
        :'required_fields' => :'Array<NormalizedDatasourceField>',
        :'optional_fields' => :'Array<NormalizedDatasourceField>',
        :'appended_fields' => :'Array<NormalizedDatasourceField>',
        :'output_fields' => :'Array<NormalizedDatasourceField>',
        :'source_type' => :'String',
        :'update_frequency' => :'String',
        :'coverage' => :'String'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Trulioo::NormalizedDatasourceGroupCountry` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Trulioo::NormalizedDatasourceGroupCountry`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.key?(:'description')
        self.description = attributes[:'description']
      end

      if attributes.key?(:'required_fields')
        if (value = attributes[:'required_fields']).is_a?(Array)
          self.required_fields = value
        end
      end

      if attributes.key?(:'optional_fields')
        if (value = attributes[:'optional_fields']).is_a?(Array)
          self.optional_fields = value
        end
      end

      if attributes.key?(:'appended_fields')
        if (value = attributes[:'appended_fields']).is_a?(Array)
          self.appended_fields = value
        end
      end

      if attributes.key?(:'output_fields')
        if (value = attributes[:'output_fields']).is_a?(Array)
          self.output_fields = value
        end
      end

      if attributes.key?(:'source_type')
        self.source_type = attributes[:'source_type']
      end

      if attributes.key?(:'update_frequency')
        self.update_frequency = attributes[:'update_frequency']
      end

      if attributes.key?(:'coverage')
        self.coverage = attributes[:'coverage']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@name.nil? && @name.to_s.length > 200
        invalid_properties.push('invalid value for "name", the character length must be smaller than or equal to 200.')
      end

      if !@name.nil? && @name.to_s.length < 0
        invalid_properties.push('invalid value for "name", the character length must be great than or equal to 0.')
      end

      if !@description.nil? && @description.to_s.length > 500
        invalid_properties.push('invalid value for "description", the character length must be smaller than or equal to 500.')
      end

      if !@description.nil? && @description.to_s.length < 0
        invalid_properties.push('invalid value for "description", the character length must be great than or equal to 0.')
      end

      if !@source_type.nil? && @source_type.to_s.length > 250
        invalid_properties.push('invalid value for "source_type", the character length must be smaller than or equal to 250.')
      end

      if !@source_type.nil? && @source_type.to_s.length < 0
        invalid_properties.push('invalid value for "source_type", the character length must be great than or equal to 0.')
      end

      if !@update_frequency.nil? && @update_frequency.to_s.length > 64
        invalid_properties.push('invalid value for "update_frequency", the character length must be smaller than or equal to 64.')
      end

      if !@update_frequency.nil? && @update_frequency.to_s.length < 0
        invalid_properties.push('invalid value for "update_frequency", the character length must be great than or equal to 0.')
      end

      if !@coverage.nil? && @coverage.to_s.length > 64
        invalid_properties.push('invalid value for "coverage", the character length must be smaller than or equal to 64.')
      end

      if !@coverage.nil? && @coverage.to_s.length < 0
        invalid_properties.push('invalid value for "coverage", the character length must be great than or equal to 0.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@name.nil? && @name.to_s.length > 200
      return false if !@name.nil? && @name.to_s.length < 0
      return false if !@description.nil? && @description.to_s.length > 500
      return false if !@description.nil? && @description.to_s.length < 0
      return false if !@source_type.nil? && @source_type.to_s.length > 250
      return false if !@source_type.nil? && @source_type.to_s.length < 0
      return false if !@update_frequency.nil? && @update_frequency.to_s.length > 64
      return false if !@update_frequency.nil? && @update_frequency.to_s.length < 0
      return false if !@coverage.nil? && @coverage.to_s.length > 64
      return false if !@coverage.nil? && @coverage.to_s.length < 0
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] name Value to be assigned
    def name=(name)
      if !name.nil? && name.to_s.length > 200
        fail ArgumentError, 'invalid value for "name", the character length must be smaller than or equal to 200.'
      end

      if !name.nil? && name.to_s.length < 0
        fail ArgumentError, 'invalid value for "name", the character length must be great than or equal to 0.'
      end

      @name = name
    end

    # Custom attribute writer method with validation
    # @param [Object] description Value to be assigned
    def description=(description)
      if !description.nil? && description.to_s.length > 500
        fail ArgumentError, 'invalid value for "description", the character length must be smaller than or equal to 500.'
      end

      if !description.nil? && description.to_s.length < 0
        fail ArgumentError, 'invalid value for "description", the character length must be great than or equal to 0.'
      end

      @description = description
    end

    # Custom attribute writer method with validation
    # @param [Object] source_type Value to be assigned
    def source_type=(source_type)
      if !source_type.nil? && source_type.to_s.length > 250
        fail ArgumentError, 'invalid value for "source_type", the character length must be smaller than or equal to 250.'
      end

      if !source_type.nil? && source_type.to_s.length < 0
        fail ArgumentError, 'invalid value for "source_type", the character length must be great than or equal to 0.'
      end

      @source_type = source_type
    end

    # Custom attribute writer method with validation
    # @param [Object] update_frequency Value to be assigned
    def update_frequency=(update_frequency)
      if !update_frequency.nil? && update_frequency.to_s.length > 64
        fail ArgumentError, 'invalid value for "update_frequency", the character length must be smaller than or equal to 64.'
      end

      if !update_frequency.nil? && update_frequency.to_s.length < 0
        fail ArgumentError, 'invalid value for "update_frequency", the character length must be great than or equal to 0.'
      end

      @update_frequency = update_frequency
    end

    # Custom attribute writer method with validation
    # @param [Object] coverage Value to be assigned
    def coverage=(coverage)
      if !coverage.nil? && coverage.to_s.length > 64
        fail ArgumentError, 'invalid value for "coverage", the character length must be smaller than or equal to 64.'
      end

      if !coverage.nil? && coverage.to_s.length < 0
        fail ArgumentError, 'invalid value for "coverage", the character length must be great than or equal to 0.'
      end

      @coverage = coverage
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          name == o.name &&
          description == o.description &&
          required_fields == o.required_fields &&
          optional_fields == o.optional_fields &&
          appended_fields == o.appended_fields &&
          output_fields == o.output_fields &&
          source_type == o.source_type &&
          update_frequency == o.update_frequency &&
          coverage == o.coverage
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [name, description, required_fields, optional_fields, appended_fields, output_fields, source_type, update_frequency, coverage].hash
    end

    # :nocov:
    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end
    # :nocov:

    # :nocov:
    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        elsif type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end
      end

      self
    end
    # :nocov:

    # :nocov:
    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :Time
        Time.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        # models (e.g. Pet) or oneOf
        klass = Trulioo.const_get(type)
        klass.respond_to?(:openapi_one_of) ? klass.build(value) : klass.build_from_hash(value)
      end
    end
    # :nocov:

    # :nocov:
    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end
    # :nocov:

    # :nocov:
    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end
    # :nocov:

    # :nocov:
    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end
    # :nocov:

    # :nocov:
    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
    # :nocov:
  end

end
