=begin
Trulioo Ruby SDK

Gem version: 1.0.3
Trulioo OpenAPI version: v1
Generated by OpenAPI Generator version: 5.0.1
=end

require 'date'
require 'time'

module Trulioo
  class Passport
    # Line 1 of the passport MRZ
    attr_accessor :mrz1

    # line 2 of the passport MRZ
    attr_accessor :mrz2

    # Passport Number
    attr_accessor :number

    # Passport's Licence day of expiry of the individual to be verified
    attr_accessor :day_of_expiry

    # Passport's Licence month of expiry of the individual to be verified
    attr_accessor :month_of_expiry

    # Passport's Licence year of expiry of the individual to be verified
    attr_accessor :year_of_expiry

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'mrz1' => :'Mrz1',
        :'mrz2' => :'Mrz2',
        :'number' => :'Number',
        :'day_of_expiry' => :'DayOfExpiry',
        :'month_of_expiry' => :'MonthOfExpiry',
        :'year_of_expiry' => :'YearOfExpiry'
      }
    end

    # Returns all the JSON keys this model knows about
    def self.acceptable_attributes
      attribute_map.values
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'mrz1' => :'String',
        :'mrz2' => :'String',
        :'number' => :'String',
        :'day_of_expiry' => :'Integer',
        :'month_of_expiry' => :'Integer',
        :'year_of_expiry' => :'Integer'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Trulioo::Passport` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Trulioo::Passport`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'mrz1')
        self.mrz1 = attributes[:'mrz1']
      end

      if attributes.key?(:'mrz2')
        self.mrz2 = attributes[:'mrz2']
      end

      if attributes.key?(:'number')
        self.number = attributes[:'number']
      end

      if attributes.key?(:'day_of_expiry')
        self.day_of_expiry = attributes[:'day_of_expiry']
      end

      if attributes.key?(:'month_of_expiry')
        self.month_of_expiry = attributes[:'month_of_expiry']
      end

      if attributes.key?(:'year_of_expiry')
        self.year_of_expiry = attributes[:'year_of_expiry']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@mrz1.nil? && @mrz1.to_s.length > 200
        invalid_properties.push('invalid value for "mrz1", the character length must be smaller than or equal to 200.')
      end

      if !@mrz1.nil? && @mrz1.to_s.length < 0
        invalid_properties.push('invalid value for "mrz1", the character length must be great than or equal to 0.')
      end

      if !@mrz2.nil? && @mrz2.to_s.length > 200
        invalid_properties.push('invalid value for "mrz2", the character length must be smaller than or equal to 200.')
      end

      if !@mrz2.nil? && @mrz2.to_s.length < 0
        invalid_properties.push('invalid value for "mrz2", the character length must be great than or equal to 0.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@mrz1.nil? && @mrz1.to_s.length > 200
      return false if !@mrz1.nil? && @mrz1.to_s.length < 0
      return false if !@mrz2.nil? && @mrz2.to_s.length > 200
      return false if !@mrz2.nil? && @mrz2.to_s.length < 0
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] mrz1 Value to be assigned
    def mrz1=(mrz1)
      if !mrz1.nil? && mrz1.to_s.length > 200
        fail ArgumentError, 'invalid value for "mrz1", the character length must be smaller than or equal to 200.'
      end

      if !mrz1.nil? && mrz1.to_s.length < 0
        fail ArgumentError, 'invalid value for "mrz1", the character length must be great than or equal to 0.'
      end

      @mrz1 = mrz1
    end

    # Custom attribute writer method with validation
    # @param [Object] mrz2 Value to be assigned
    def mrz2=(mrz2)
      if !mrz2.nil? && mrz2.to_s.length > 200
        fail ArgumentError, 'invalid value for "mrz2", the character length must be smaller than or equal to 200.'
      end

      if !mrz2.nil? && mrz2.to_s.length < 0
        fail ArgumentError, 'invalid value for "mrz2", the character length must be great than or equal to 0.'
      end

      @mrz2 = mrz2
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          mrz1 == o.mrz1 &&
          mrz2 == o.mrz2 &&
          number == o.number &&
          day_of_expiry == o.day_of_expiry &&
          month_of_expiry == o.month_of_expiry &&
          year_of_expiry == o.year_of_expiry
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [mrz1, mrz2, number, day_of_expiry, month_of_expiry, year_of_expiry].hash
    end

    # :nocov:
    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end
    # :nocov:

    # :nocov:
    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        elsif type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end
      end

      self
    end
    # :nocov:

    # :nocov:
    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :Time
        Time.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        # models (e.g. Pet) or oneOf
        klass = Trulioo.const_get(type)
        klass.respond_to?(:openapi_one_of) ? klass.build(value) : klass.build_from_hash(value)
      end
    end
    # :nocov:

    # :nocov:
    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end
    # :nocov:

    # :nocov:
    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end
    # :nocov:

    # :nocov:
    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end
    # :nocov:

    # :nocov:
    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
    # :nocov:
  end

end
