=begin
Trulioo Ruby SDK

Gem version: 1.0.3
Trulioo OpenAPI version: v1
Generated by OpenAPI Generator version: 5.0.1
=end

require 'date'
require 'time'

module Trulioo
  # Personal Information
  class PersonInfo
    # First name of the individual to be verified
    attr_accessor :first_given_name

    # Second given name of the individual to be verified
    attr_accessor :middle_name

    # First (paternal) family name of the individual to be verified
    attr_accessor :first_sur_name

    # second family name of the individual to be verified
    attr_accessor :second_surname

    # Enter full name in ISO Latin-1 character set
    attr_accessor :iso_latin1_name

    # Day of birth date (e.g. 23 for a date of birth of 23/11/1975)
    attr_accessor :day_of_birth

    # Month of birth date (e.g. 11 for a date of birth of 23/11/1975)
    attr_accessor :month_of_birth

    # Year of birth date (e.g. 1975 for a date of birth of 23/11/1975)
    attr_accessor :year_of_birth

    # Minimum permitted age of the individual
    attr_accessor :minimum_age

    # Single character M / F (M = Male, F = Female)
    attr_accessor :gender

    attr_accessor :additional_fields

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'first_given_name' => :'FirstGivenName',
        :'middle_name' => :'MiddleName',
        :'first_sur_name' => :'FirstSurName',
        :'second_surname' => :'SecondSurname',
        :'iso_latin1_name' => :'ISOLatin1Name',
        :'day_of_birth' => :'DayOfBirth',
        :'month_of_birth' => :'MonthOfBirth',
        :'year_of_birth' => :'YearOfBirth',
        :'minimum_age' => :'MinimumAge',
        :'gender' => :'Gender',
        :'additional_fields' => :'AdditionalFields'
      }
    end

    # Returns all the JSON keys this model knows about
    def self.acceptable_attributes
      attribute_map.values
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'first_given_name' => :'String',
        :'middle_name' => :'String',
        :'first_sur_name' => :'String',
        :'second_surname' => :'String',
        :'iso_latin1_name' => :'String',
        :'day_of_birth' => :'Integer',
        :'month_of_birth' => :'Integer',
        :'year_of_birth' => :'Integer',
        :'minimum_age' => :'Integer',
        :'gender' => :'String',
        :'additional_fields' => :'PersonInfoAdditionalFields'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Trulioo::PersonInfo` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Trulioo::PersonInfo`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'first_given_name')
        self.first_given_name = attributes[:'first_given_name']
      end

      if attributes.key?(:'middle_name')
        self.middle_name = attributes[:'middle_name']
      end

      if attributes.key?(:'first_sur_name')
        self.first_sur_name = attributes[:'first_sur_name']
      end

      if attributes.key?(:'second_surname')
        self.second_surname = attributes[:'second_surname']
      end

      if attributes.key?(:'iso_latin1_name')
        self.iso_latin1_name = attributes[:'iso_latin1_name']
      end

      if attributes.key?(:'day_of_birth')
        self.day_of_birth = attributes[:'day_of_birth']
      end

      if attributes.key?(:'month_of_birth')
        self.month_of_birth = attributes[:'month_of_birth']
      end

      if attributes.key?(:'year_of_birth')
        self.year_of_birth = attributes[:'year_of_birth']
      end

      if attributes.key?(:'minimum_age')
        self.minimum_age = attributes[:'minimum_age']
      end

      if attributes.key?(:'gender')
        self.gender = attributes[:'gender']
      end

      if attributes.key?(:'additional_fields')
        self.additional_fields = attributes[:'additional_fields']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@first_given_name.nil? && @first_given_name.to_s.length > 200
        invalid_properties.push('invalid value for "first_given_name", the character length must be smaller than or equal to 200.')
      end

      if !@first_given_name.nil? && @first_given_name.to_s.length < 0
        invalid_properties.push('invalid value for "first_given_name", the character length must be great than or equal to 0.')
      end

      if !@middle_name.nil? && @middle_name.to_s.length > 200
        invalid_properties.push('invalid value for "middle_name", the character length must be smaller than or equal to 200.')
      end

      if !@middle_name.nil? && @middle_name.to_s.length < 0
        invalid_properties.push('invalid value for "middle_name", the character length must be great than or equal to 0.')
      end

      if !@first_sur_name.nil? && @first_sur_name.to_s.length > 200
        invalid_properties.push('invalid value for "first_sur_name", the character length must be smaller than or equal to 200.')
      end

      if !@first_sur_name.nil? && @first_sur_name.to_s.length < 0
        invalid_properties.push('invalid value for "first_sur_name", the character length must be great than or equal to 0.')
      end

      if !@second_surname.nil? && @second_surname.to_s.length > 200
        invalid_properties.push('invalid value for "second_surname", the character length must be smaller than or equal to 200.')
      end

      if !@second_surname.nil? && @second_surname.to_s.length < 0
        invalid_properties.push('invalid value for "second_surname", the character length must be great than or equal to 0.')
      end

      if !@iso_latin1_name.nil? && @iso_latin1_name.to_s.length > 200
        invalid_properties.push('invalid value for "iso_latin1_name", the character length must be smaller than or equal to 200.')
      end

      if !@iso_latin1_name.nil? && @iso_latin1_name.to_s.length < 0
        invalid_properties.push('invalid value for "iso_latin1_name", the character length must be great than or equal to 0.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@first_given_name.nil? && @first_given_name.to_s.length > 200
      return false if !@first_given_name.nil? && @first_given_name.to_s.length < 0
      return false if !@middle_name.nil? && @middle_name.to_s.length > 200
      return false if !@middle_name.nil? && @middle_name.to_s.length < 0
      return false if !@first_sur_name.nil? && @first_sur_name.to_s.length > 200
      return false if !@first_sur_name.nil? && @first_sur_name.to_s.length < 0
      return false if !@second_surname.nil? && @second_surname.to_s.length > 200
      return false if !@second_surname.nil? && @second_surname.to_s.length < 0
      return false if !@iso_latin1_name.nil? && @iso_latin1_name.to_s.length > 200
      return false if !@iso_latin1_name.nil? && @iso_latin1_name.to_s.length < 0
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] first_given_name Value to be assigned
    def first_given_name=(first_given_name)
      if !first_given_name.nil? && first_given_name.to_s.length > 200
        fail ArgumentError, 'invalid value for "first_given_name", the character length must be smaller than or equal to 200.'
      end

      if !first_given_name.nil? && first_given_name.to_s.length < 0
        fail ArgumentError, 'invalid value for "first_given_name", the character length must be great than or equal to 0.'
      end

      @first_given_name = first_given_name
    end

    # Custom attribute writer method with validation
    # @param [Object] middle_name Value to be assigned
    def middle_name=(middle_name)
      if !middle_name.nil? && middle_name.to_s.length > 200
        fail ArgumentError, 'invalid value for "middle_name", the character length must be smaller than or equal to 200.'
      end

      if !middle_name.nil? && middle_name.to_s.length < 0
        fail ArgumentError, 'invalid value for "middle_name", the character length must be great than or equal to 0.'
      end

      @middle_name = middle_name
    end

    # Custom attribute writer method with validation
    # @param [Object] first_sur_name Value to be assigned
    def first_sur_name=(first_sur_name)
      if !first_sur_name.nil? && first_sur_name.to_s.length > 200
        fail ArgumentError, 'invalid value for "first_sur_name", the character length must be smaller than or equal to 200.'
      end

      if !first_sur_name.nil? && first_sur_name.to_s.length < 0
        fail ArgumentError, 'invalid value for "first_sur_name", the character length must be great than or equal to 0.'
      end

      @first_sur_name = first_sur_name
    end

    # Custom attribute writer method with validation
    # @param [Object] second_surname Value to be assigned
    def second_surname=(second_surname)
      if !second_surname.nil? && second_surname.to_s.length > 200
        fail ArgumentError, 'invalid value for "second_surname", the character length must be smaller than or equal to 200.'
      end

      if !second_surname.nil? && second_surname.to_s.length < 0
        fail ArgumentError, 'invalid value for "second_surname", the character length must be great than or equal to 0.'
      end

      @second_surname = second_surname
    end

    # Custom attribute writer method with validation
    # @param [Object] iso_latin1_name Value to be assigned
    def iso_latin1_name=(iso_latin1_name)
      if !iso_latin1_name.nil? && iso_latin1_name.to_s.length > 200
        fail ArgumentError, 'invalid value for "iso_latin1_name", the character length must be smaller than or equal to 200.'
      end

      if !iso_latin1_name.nil? && iso_latin1_name.to_s.length < 0
        fail ArgumentError, 'invalid value for "iso_latin1_name", the character length must be great than or equal to 0.'
      end

      @iso_latin1_name = iso_latin1_name
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          first_given_name == o.first_given_name &&
          middle_name == o.middle_name &&
          first_sur_name == o.first_sur_name &&
          second_surname == o.second_surname &&
          iso_latin1_name == o.iso_latin1_name &&
          day_of_birth == o.day_of_birth &&
          month_of_birth == o.month_of_birth &&
          year_of_birth == o.year_of_birth &&
          minimum_age == o.minimum_age &&
          gender == o.gender &&
          additional_fields == o.additional_fields
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [first_given_name, middle_name, first_sur_name, second_surname, iso_latin1_name, day_of_birth, month_of_birth, year_of_birth, minimum_age, gender, additional_fields].hash
    end

    # :nocov:
    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end
    # :nocov:

    # :nocov:
    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        elsif type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end
      end

      self
    end
    # :nocov:

    # :nocov:
    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :Time
        Time.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        # models (e.g. Pet) or oneOf
        klass = Trulioo.const_get(type)
        klass.respond_to?(:openapi_one_of) ? klass.build(value) : klass.build_from_hash(value)
      end
    end
    # :nocov:

    # :nocov:
    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end
    # :nocov:

    # :nocov:
    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end
    # :nocov:

    # :nocov:
    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end
    # :nocov:

    # :nocov:
    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
    # :nocov:
  end

end
