=begin
Trulioo Ruby SDK

Gem version: 1.0.3
Trulioo OpenAPI version: v1
Generated by OpenAPI Generator version: 5.0.1
=end

require 'date'
require 'time'

module Trulioo
  class TestEntityDataFields
    # Friendly name for the test entity
    attr_accessor :test_entity_name

    attr_accessor :person_info

    attr_accessor :location

    attr_accessor :communication

    attr_accessor :driver_licence

    # National Identification Information
    attr_accessor :national_ids

    attr_accessor :passport

    attr_accessor :document

    attr_accessor :business

    # CountrySpecific fields  {\"CountryCode\" : {\"Field1\" : \"Value\",  \"Field2\" : \"Value\"  }}
    attr_accessor :country_specific

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'test_entity_name' => :'TestEntityName',
        :'person_info' => :'PersonInfo',
        :'location' => :'Location',
        :'communication' => :'Communication',
        :'driver_licence' => :'DriverLicence',
        :'national_ids' => :'NationalIds',
        :'passport' => :'Passport',
        :'document' => :'Document',
        :'business' => :'Business',
        :'country_specific' => :'CountrySpecific'
      }
    end

    # Returns all the JSON keys this model knows about
    def self.acceptable_attributes
      attribute_map.values
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'test_entity_name' => :'String',
        :'person_info' => :'PersonInfo',
        :'location' => :'Location',
        :'communication' => :'Communication',
        :'driver_licence' => :'DriverLicence',
        :'national_ids' => :'Array<NationalId>',
        :'passport' => :'Passport',
        :'document' => :'Document',
        :'business' => :'Business',
        :'country_specific' => :'Hash<String, Hash<String, String>>'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Trulioo::TestEntityDataFields` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Trulioo::TestEntityDataFields`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'test_entity_name')
        self.test_entity_name = attributes[:'test_entity_name']
      end

      if attributes.key?(:'person_info')
        self.person_info = attributes[:'person_info']
      end

      if attributes.key?(:'location')
        self.location = attributes[:'location']
      end

      if attributes.key?(:'communication')
        self.communication = attributes[:'communication']
      end

      if attributes.key?(:'driver_licence')
        self.driver_licence = attributes[:'driver_licence']
      end

      if attributes.key?(:'national_ids')
        if (value = attributes[:'national_ids']).is_a?(Array)
          self.national_ids = value
        end
      end

      if attributes.key?(:'passport')
        self.passport = attributes[:'passport']
      end

      if attributes.key?(:'document')
        self.document = attributes[:'document']
      end

      if attributes.key?(:'business')
        self.business = attributes[:'business']
      end

      if attributes.key?(:'country_specific')
        if (value = attributes[:'country_specific']).is_a?(Hash)
          self.country_specific = value
        end
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          test_entity_name == o.test_entity_name &&
          person_info == o.person_info &&
          location == o.location &&
          communication == o.communication &&
          driver_licence == o.driver_licence &&
          national_ids == o.national_ids &&
          passport == o.passport &&
          document == o.document &&
          business == o.business &&
          country_specific == o.country_specific
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [test_entity_name, person_info, location, communication, driver_licence, national_ids, passport, document, business, country_specific].hash
    end

    # :nocov:
    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end
    # :nocov:

    # :nocov:
    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        elsif type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end
      end

      self
    end
    # :nocov:

    # :nocov:
    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :Time
        Time.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        # models (e.g. Pet) or oneOf
        klass = Trulioo.const_get(type)
        klass.respond_to?(:openapi_one_of) ? klass.build(value) : klass.build_from_hash(value)
      end
    end
    # :nocov:

    # :nocov:
    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end
    # :nocov:

    # :nocov:
    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end
    # :nocov:

    # :nocov:
    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end
    # :nocov:

    # :nocov:
    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
    # :nocov:
  end

end
