=begin
Trulioo Ruby SDK

Gem version: 1.0.3
Trulioo OpenAPI version: v1
Generated by OpenAPI Generator version: 5.0.1
=end

require 'date'
require 'time'

module Trulioo
  # Transaction Status
  class TransactionStatus
    # Transaction ID of the transaction
    attr_accessor :transaction_id

    # Transaction Record ID of the transaction available once the transaction has finished processing
    attr_accessor :transaction_record_id

    # Status of the transaction. Possible Values: Uploading, Processing, Completed, InProgress, Failed, WaitAsync, ToBeResumed, Canceled, TimeoutCanceled. Call GetTransactionRecord when status changes to Completed, Failed, Canceled or TimeoutCanceled to get the verification results.
    attr_accessor :status

    # Uploaded date for transaction
    attr_accessor :uploaded_dt

    # Set to true when transaction has timed out
    attr_accessor :is_timed_out

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'transaction_id' => :'TransactionId',
        :'transaction_record_id' => :'TransactionRecordId',
        :'status' => :'Status',
        :'uploaded_dt' => :'UploadedDt',
        :'is_timed_out' => :'IsTimedOut'
      }
    end

    # Returns all the JSON keys this model knows about
    def self.acceptable_attributes
      attribute_map.values
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'transaction_id' => :'String',
        :'transaction_record_id' => :'String',
        :'status' => :'String',
        :'uploaded_dt' => :'Time',
        :'is_timed_out' => :'Boolean'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Trulioo::TransactionStatus` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Trulioo::TransactionStatus`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'transaction_id')
        self.transaction_id = attributes[:'transaction_id']
      end

      if attributes.key?(:'transaction_record_id')
        self.transaction_record_id = attributes[:'transaction_record_id']
      end

      if attributes.key?(:'status')
        self.status = attributes[:'status']
      end

      if attributes.key?(:'uploaded_dt')
        self.uploaded_dt = attributes[:'uploaded_dt']
      end

      if attributes.key?(:'is_timed_out')
        self.is_timed_out = attributes[:'is_timed_out']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@transaction_id.nil? && @transaction_id.to_s.length > 36
        invalid_properties.push('invalid value for "transaction_id", the character length must be smaller than or equal to 36.')
      end

      if !@transaction_id.nil? && @transaction_id.to_s.length < 0
        invalid_properties.push('invalid value for "transaction_id", the character length must be great than or equal to 0.')
      end

      if !@transaction_record_id.nil? && @transaction_record_id.to_s.length > 36
        invalid_properties.push('invalid value for "transaction_record_id", the character length must be smaller than or equal to 36.')
      end

      if !@transaction_record_id.nil? && @transaction_record_id.to_s.length < 0
        invalid_properties.push('invalid value for "transaction_record_id", the character length must be great than or equal to 0.')
      end

      if !@status.nil? && @status.to_s.length > 25
        invalid_properties.push('invalid value for "status", the character length must be smaller than or equal to 25.')
      end

      if !@status.nil? && @status.to_s.length < 0
        invalid_properties.push('invalid value for "status", the character length must be great than or equal to 0.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@transaction_id.nil? && @transaction_id.to_s.length > 36
      return false if !@transaction_id.nil? && @transaction_id.to_s.length < 0
      return false if !@transaction_record_id.nil? && @transaction_record_id.to_s.length > 36
      return false if !@transaction_record_id.nil? && @transaction_record_id.to_s.length < 0
      return false if !@status.nil? && @status.to_s.length > 25
      return false if !@status.nil? && @status.to_s.length < 0
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] transaction_id Value to be assigned
    def transaction_id=(transaction_id)
      if !transaction_id.nil? && transaction_id.to_s.length > 36
        fail ArgumentError, 'invalid value for "transaction_id", the character length must be smaller than or equal to 36.'
      end

      if !transaction_id.nil? && transaction_id.to_s.length < 0
        fail ArgumentError, 'invalid value for "transaction_id", the character length must be great than or equal to 0.'
      end

      @transaction_id = transaction_id
    end

    # Custom attribute writer method with validation
    # @param [Object] transaction_record_id Value to be assigned
    def transaction_record_id=(transaction_record_id)
      if !transaction_record_id.nil? && transaction_record_id.to_s.length > 36
        fail ArgumentError, 'invalid value for "transaction_record_id", the character length must be smaller than or equal to 36.'
      end

      if !transaction_record_id.nil? && transaction_record_id.to_s.length < 0
        fail ArgumentError, 'invalid value for "transaction_record_id", the character length must be great than or equal to 0.'
      end

      @transaction_record_id = transaction_record_id
    end

    # Custom attribute writer method with validation
    # @param [Object] status Value to be assigned
    def status=(status)
      if !status.nil? && status.to_s.length > 25
        fail ArgumentError, 'invalid value for "status", the character length must be smaller than or equal to 25.'
      end

      if !status.nil? && status.to_s.length < 0
        fail ArgumentError, 'invalid value for "status", the character length must be great than or equal to 0.'
      end

      @status = status
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          transaction_id == o.transaction_id &&
          transaction_record_id == o.transaction_record_id &&
          status == o.status &&
          uploaded_dt == o.uploaded_dt &&
          is_timed_out == o.is_timed_out
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [transaction_id, transaction_record_id, status, uploaded_dt, is_timed_out].hash
    end

    # :nocov:
    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end
    # :nocov:

    # :nocov:
    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        elsif type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end
      end

      self
    end
    # :nocov:

    # :nocov:
    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :Time
        Time.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        # models (e.g. Pet) or oneOf
        klass = Trulioo.const_get(type)
        klass.respond_to?(:openapi_one_of) ? klass.build(value) : klass.build_from_hash(value)
      end
    end
    # :nocov:

    # :nocov:
    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end
    # :nocov:

    # :nocov:
    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end
    # :nocov:

    # :nocov:
    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end
    # :nocov:

    # :nocov:
    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
    # :nocov:
  end

end
